'''
MIT License

Copyright (c) 2018, Selectom.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
'''

# Based on https://developers.facebook.com/docs/marketing-api/reference/ad-account/timezone-ids/v2.12

# 1 -> TZ_AMERICA_LOS_ANGELES
facebookTimezoneIdToTimezoneCode = {
    0: 'TZ_UNKNOWN',
    1: 'TZ_AMERICA_LOS_ANGELES',
    2: 'TZ_AMERICA_DENVER',
    3: 'TZ_PACIFIC_HONOLULU',
    4: 'TZ_AMERICA_ANCHORAGE',
    5: 'TZ_AMERICA_PHOENIX',
    6: 'TZ_AMERICA_CHICAGO',
    7: 'TZ_AMERICA_NEW_YORK',
    8: 'TZ_ASIA_DUBAI',
    9: 'TZ_AMERICA_ARGENTINA_SAN_LUIS',
    10: 'TZ_AMERICA_ARGENTINA_BUENOS_AIRES',
    11: 'TZ_AMERICA_ARGENTINA_SALTA',
    12: 'TZ_EUROPE_VIENNA',
    13: 'TZ_AUSTRALIA_PERTH',
    14: 'TZ_AUSTRALIA_BROKEN_HILL',
    15: 'TZ_AUSTRALIA_SYDNEY',
    16: 'TZ_EUROPE_SARAJEVO',
    17: 'TZ_ASIA_DHAKA',
    18: 'TZ_EUROPE_BRUSSELS',
    19: 'TZ_EUROPE_SOFIA',
    20: 'TZ_ASIA_BAHRAIN',
    21: 'TZ_AMERICA_LA_PAZ',
    22: 'TZ_AMERICA_NORONHA',
    23: 'TZ_AMERICA_CAMPO_GRANDE',
    24: 'TZ_AMERICA_BELEM',
    25: 'TZ_AMERICA_SAO_PAULO',
    26: 'TZ_AMERICA_NASSAU',
    27: 'TZ_AMERICA_DAWSON',
    28: 'TZ_AMERICA_VANCOUVER',
    29: 'TZ_AMERICA_DAWSON_CREEK',
    30: 'TZ_AMERICA_EDMONTON',
    31: 'TZ_AMERICA_RAINY_RIVER',
    32: 'TZ_AMERICA_REGINA',
    33: 'TZ_AMERICA_ATIKOKAN',
    34: 'TZ_AMERICA_IQALUIT',
    35: 'TZ_AMERICA_TORONTO',
    36: 'TZ_AMERICA_BLANC_SABLON',
    37: 'TZ_AMERICA_HALIFAX',
    38: 'TZ_AMERICA_ST_JOHNS',
    39: 'TZ_EUROPE_ZURICH',
    40: 'TZ_PACIFIC_EASTER',
    41: 'TZ_AMERICA_SANTIAGO',
    42: 'TZ_ASIA_SHANGHAI',
    43: 'TZ_AMERICA_BOGOTA',
    44: 'TZ_AMERICA_COSTA_RICA',
    45: 'TZ_ASIA_NICOSIA',
    46: 'TZ_EUROPE_PRAGUE',
    47: 'TZ_EUROPE_BERLIN',
    48: 'TZ_EUROPE_COPENHAGEN',
    49: 'TZ_AMERICA_SANTO_DOMINGO',
    50: 'TZ_PACIFIC_GALAPAGOS',
    51: 'TZ_AMERICA_GUAYAQUIL',
    52: 'TZ_EUROPE_TALLINN',
    53: 'TZ_AFRICA_CAIRO',
    54: 'TZ_ATLANTIC_CANARY',
    55: 'TZ_EUROPE_MADRID',
    56: 'TZ_EUROPE_HELSINKI',
    57: 'TZ_EUROPE_PARIS',
    58: 'TZ_EUROPE_LONDON',
    59: 'TZ_AFRICA_ACCRA',
    60: 'TZ_EUROPE_ATHENS',
    61: 'TZ_AMERICA_GUATEMALA',
    62: 'TZ_ASIA_HONG_KONG',
    63: 'TZ_AMERICA_TEGUCIGALPA',
    64: 'TZ_EUROPE_ZAGREB',
    65: 'TZ_EUROPE_BUDAPEST',
    66: 'TZ_ASIA_JAKARTA',
    67: 'TZ_ASIA_MAKASSAR',
    68: 'TZ_ASIA_JAYAPURA',
    69: 'TZ_EUROPE_DUBLIN',
    70: 'TZ_ASIA_JERUSALEM',
    71: 'TZ_ASIA_KOLKATA',
    72: 'TZ_ASIA_BAGHDAD',
    73: 'TZ_ATLANTIC_REYKJAVIK',
    74: 'TZ_EUROPE_ROME',
    75: 'TZ_AMERICA_JAMAICA',
    76: 'TZ_ASIA_AMMAN',
    77: 'TZ_ASIA_TOKYO',
    78: 'TZ_AFRICA_NAIROBI',
    79: 'TZ_ASIA_SEOUL',
    80: 'TZ_ASIA_KUWAIT',
    81: 'TZ_ASIA_BEIRUT',
    82: 'TZ_ASIA_COLOMBO',
    83: 'TZ_EUROPE_VILNIUS',
    84: 'TZ_EUROPE_LUXEMBOURG',
    85: 'TZ_EUROPE_RIGA',
    86: 'TZ_AFRICA_CASABLANCA',
    87: 'TZ_EUROPE_SKOPJE',
    88: 'TZ_EUROPE_MALTA',
    89: 'TZ_INDIAN_MAURITIUS',
    90: 'TZ_INDIAN_MALDIVES',
    91: 'TZ_AMERICA_TIJUANA',
    92: 'TZ_AMERICA_HERMOSILLO',
    93: 'TZ_AMERICA_MAZATLAN',
    94: 'TZ_AMERICA_MEXICO_CITY',
    95: 'TZ_ASIA_KUALA_LUMPUR',
    96: 'TZ_AFRICA_LAGOS',
    97: 'TZ_AMERICA_MANAGUA',
    98: 'TZ_EUROPE_AMSTERDAM',
    99: 'TZ_EUROPE_OSLO',
    100: 'TZ_PACIFIC_AUCKLAND',
    101: 'TZ_ASIA_MUSCAT',
    102: 'TZ_AMERICA_PANAMA',
    103: 'TZ_AMERICA_LIMA',
    104: 'TZ_ASIA_MANILA',
    105: 'TZ_ASIA_KARACHI',
    106: 'TZ_EUROPE_WARSAW',
    107: 'TZ_AMERICA_PUERTO_RICO',
    108: 'TZ_ASIA_GAZA',
    109: 'TZ_ATLANTIC_AZORES',
    110: 'TZ_EUROPE_LISBON',
    111: 'TZ_AMERICA_ASUNCION',
    112: 'TZ_ASIA_QATAR',
    113: 'TZ_EUROPE_BUCHAREST',
    114: 'TZ_EUROPE_BELGRADE',
    115: 'TZ_EUROPE_KALININGRAD',
    116: 'TZ_EUROPE_MOSCOW',
    117: 'TZ_EUROPE_SAMARA',
    118: 'TZ_ASIA_YEKATERINBURG',
    119: 'TZ_ASIA_OMSK',
    120: 'TZ_ASIA_KRASNOYARSK',
    121: 'TZ_ASIA_IRKUTSK',
    122: 'TZ_ASIA_YAKUTSK',
    123: 'TZ_ASIA_VLADIVOSTOK',
    124: 'TZ_ASIA_MAGADAN',
    125: 'TZ_ASIA_KAMCHATKA',
    126: 'TZ_ASIA_RIYADH',
    127: 'TZ_EUROPE_STOCKHOLM',
    128: 'TZ_ASIA_SINGAPORE',
    129: 'TZ_EUROPE_LJUBLJANA',
    130: 'TZ_EUROPE_BRATISLAVA',
    131: 'TZ_AMERICA_EL_SALVADOR',
    132: 'TZ_ASIA_BANGKOK',
    133: 'TZ_AFRICA_TUNIS',
    134: 'TZ_EUROPE_ISTANBUL',
    135: 'TZ_AMERICA_PORT_OF_SPAIN',
    136: 'TZ_ASIA_TAIPEI',
    137: 'TZ_EUROPE_KIEV',
    138: 'TZ_AMERICA_MONTEVIDEO',
    139: 'TZ_AMERICA_CARACAS',
    140: 'TZ_ASIA_HO_CHI_MINH',
    141: 'TZ_AFRICA_JOHANNESBURG',
    142: 'TZ_NUM_TIMEZONES'
}
# TZ_AMERICA_LOS_ANGELES -> 1
facebookTimezoneCodeToTimezoneId = {v: k for k, v in facebookTimezoneIdToTimezoneCode.items()}

# 1 -> TZ_AMERICA_LOS_ANGELES
facebookTimezoneIdToTimezoneName = {
    0: 'Unknown',
    1: 'America/Los_Angeles',
    2: 'America/Denver',
    3: 'Pacific/Honolulu',
    4: 'America/Anchorage',
    5: 'America/Phoenix',
    6: 'America/Chicago',
    7: 'America/New_York',
    8: 'Asia/Dubai',
    9: 'America/Argentina_San_Luis',
    10: 'America/Argentina_Buenos_Aires',
    11: 'America/Argentina_Salta',
    12: 'Europe/Vienna',
    13: 'Australia/Perth',
    14: 'Australia/Broken_Hill',
    15: 'Australia/Sydney',
    16: 'Europe/Sarajevo',
    17: 'Asia/Dhaka',
    18: 'Europe/Brussels',
    19: 'Europe/Sofia',
    20: 'Asia/Bahrain',
    21: 'America/La_Paz',
    22: 'America/Noronha',
    23: 'America/Campo_Grande',
    24: 'America/Belem',
    25: 'America/Sao_Paulo',
    26: 'America/Nassau',
    27: 'America/Dawson',
    28: 'America/Vancouver',
    29: 'America/Dawson_Creek',
    30: 'America/Edmonton',
    31: 'America/Rainy_River',
    32: 'America/Regina',
    33: 'America/Atikokan',
    34: 'America/Iqaluit',
    35: 'America/Toronto',
    36: 'America/Blanc_Sablon',
    37: 'America/Halifax',
    38: 'America/St_Johns',
    39: 'Europe/Zurich',
    40: 'Pacific/Easter',
    41: 'America/Santiago',
    42: 'Asia/Shanghai',
    43: 'America/Bogota',
    44: 'America/Costa_Rica',
    45: 'Asia/Nicosia',
    46: 'Europe/Prague',
    47: 'Europe/Berlin',
    48: 'Europe/Copenhagen',
    49: 'America/Santo_Domingo',
    50: 'Pacific/Galapagos',
    51: 'America/Guayaquil',
    52: 'Europe/Tallinn',
    53: 'Africa/Cairo',
    54: 'Atlantic/Canary',
    55: 'Europe/Madrid',
    56: 'Europe/Helsinki',
    57: 'Europe/Paris',
    58: 'Europe/London',
    59: 'Africa/Accra',
    60: 'Europe/Athens',
    61: 'America/Guatemala',
    62: 'Asia/Hong_Kong',
    63: 'America/Tegucigalpa',
    64: 'Europe/Zagreb',
    65: 'Europe/Budapest',
    66: 'Asia/Jakarta',
    67: 'Asia/Makassar',
    68: 'Asia/Jayapura',
    69: 'Europe/Dublin',
    70: 'Asia/Jerusalem',
    71: 'Asia/Kolkata',
    72: 'Asia/Baghdad',
    73: 'Atlantic/Reykjavik',
    74: 'Europe/Rome',
    75: 'America/Jamaica',
    76: 'Asia/Amman',
    77: 'Asia/Tokyo',
    78: 'Africa/Nairobi',
    79: 'Asia/Seoul',
    80: 'Asia/Kuwait',
    81: 'Asia/Beirut',
    82: 'Asia/Colombo',
    83: 'Europe/Vilnius',
    84: 'Europe/Luxembourg',
    85: 'Europe/Riga',
    86: 'Africa/Casablanca',
    87: 'Europe/Skopje',
    88: 'Europe/Malta',
    89: 'Indian/Mauritius',
    90: 'Indian/Maldives',
    91: 'America/Tijuana',
    92: 'America/Hermosillo',
    93: 'America/Mazatlan',
    94: 'America/Mexico_City',
    95: 'Asia/Kuala_Lumpur',
    96: 'Africa/Lagos',
    97: 'America/Managua',
    98: 'Europe/Amsterdam',
    99: 'Europe/Oslo',
    100: 'Pacific/Auckland',
    101: 'Asia/Muscat',
    102: 'America/Panama',
    103: 'America/Lima',
    104: 'Asia/Manila',
    105: 'Asia/Karachi',
    106: 'Europe/Warsaw',
    107: 'America/Puerto_Rico',
    108: 'Asia/Gaza',
    109: 'Atlantic/Azores',
    110: 'Europe/Lisbon',
    111: 'America/Asuncion',
    112: 'Asia/Qatar',
    113: 'Europe/Bucharest',
    114: 'Europe/Belgrade',
    115: 'Europe/Kaliningrad',
    116: 'Europe/Moscow',
    117: 'Europe/Samara',
    118: 'Asia/Yekaterinburg',
    119: 'Asia/Omsk',
    120: 'Asia/Krasnoyarsk',
    121: 'Asia/Irkutsk',
    122: 'Asia/Yakutsk',
    123: 'Asia/Vladivostok',
    124: 'Asia/Magadan',
    125: 'Asia/Kamchatka',
    126: 'Asia/Riyadh',
    127: 'Europe/Stockholm',
    128: 'Asia/Singapore',
    129: 'Europe/Ljubljana',
    130: 'Europe/Bratislava',
    131: 'America/El_Salvador',
    132: 'Asia/Bangkok',
    133: 'Africa/Tunis',
    134: 'Europe/Istanbul',
    135: 'America/Port_Of_Spain',
    136: 'Asia/Taipei',
    137: 'Europe/Kiev',
    138: 'America/Montevideo',
    139: 'America/Caracas',
    140: 'Asia/Ho_Chi_Minh',
    141: 'Africa/Johannesburg',
    142: 'Num/Timezones'
}
# TZ_AMERICA_LOS_ANGELES -> 1
facebookTimezoneNameToTimezoneId = {v: k for k, v in facebookTimezoneIdToTimezoneName.items()}

# TZ_AMERICA_LOS_ANGELES -> America/Los_Angeles
facebookTimezoneCodeToTimezoneName = \
    {k: facebookTimezoneIdToTimezoneName[v] for (k, v) in facebookTimezoneCodeToTimezoneId.items()}
# America/Los_Angeles -> TZ_AMERICA_LOS_ANGELES
facebookTimezoneNameToTimezoneCode = {v: k for k, v in facebookTimezoneCodeToTimezoneName.items()}

# 5 -> Etc/GMT+5
def timezoneNameFromTimezoneOffset(timezoneOffset):
    '''
    Returns a timezone based on the timezone offset, as returned in the 'timezone' field of:
    https://developers.facebook.com/docs/graph-api/reference/v2.12/user

    :param timezoneOffset: Float, -24.0 to 24.0
    :return: timezoneName
    '''

    # TODO: Handle 0.25, 0.5 and 0.75 values - these actually exist
    timezoneOffset = round(timezoneOffset)

    # unfortunately we need these 2 ifs, because pytz doesn't support +13 adn +14 timezones
    if timezoneOffset == 13:
        return 'Pacific/Auckland'
    elif timezoneOffset == 14:
        return 'Pacific/Kiritimati'
    elif timezoneOffset > 0:
        return 'Etc/GMT+%d' % timezoneOffset
    elif timezoneOffset == 0:
        return 'Etc/GMT'
    else:
        return 'Etc/GMT%d' % timezoneOffset